#ifndef __LOTUS_CARD_DRIVER_H__
#define __LOTUS_CARD_DRIVER_H__

#if 1 //作为VC demo调用头文件 把0改为1
		typedef int		 						BOOL;
		typedef unsigned char		 					byte;
		//#undef FALSE
		//#undef TRUE
		//#undef NULL

		#define FALSE   0
		#define TRUE    1
		#define NULL    0
        #define WINAPI __stdcall

	#define		RT_NOT_HALT				0x26
	#define		RT_ALL					0x52

	#define		AM_A					0x60
	#define		AM_B					0x61
#define		COS_RESULT_BUFFER_LENGTH		256
#define		COS_SEND_BUFFER_LENGTH			256

//#define		FOR_WINDOWS10					//WINDOWS 10 用long long
#ifdef FOR_WINDOWS10
	typedef long long LotusHandle;				//针对句柄单独搞个类型 便于改动
#else
	typedef long LotusHandle;				//针对句柄单独搞个类型 便于改动
#endif
	typedef BOOL (*LotusCardExtendReadWriteCallBack)(BOOL bRead, unsigned char * pReadWriteBuffer, int nBufferLength);
	typedef void (*LotusCardWrite2FlashCallBack)(unsigned int unCurrentPos, unsigned int unFileLength);
	typedef struct _LotusCardParamStruct
	{
		/**
		* 卡片类型
		*/
		int nCardType;
		/**
		* 8字节卡号
		*/
		byte arrCardNo[8];
		
		/**
		* 卡片容量大小
		*/
		int nCardSize;
		
		/**
		* 读写缓冲
		*/
		byte arrBuffer[64];

		int nBufferSize;
		
		/**
		* 密钥
		*/
		byte arrKeys[64];
		int nKeysSize;
		/**
		* pCosResultBuffer COS执行结果缓冲
		*/
		byte arrCosResultBuffer[COS_RESULT_BUFFER_LENGTH];
		/**
		* unCosReultBufferLength COS执行结果缓冲长度 
		*/
		unsigned int unCosReultBufferLength;
	/**
	 * pCosSendBuffer COS指令发送缓冲
	 */
	byte arrCosSendBuffer[COS_SEND_BUFFER_LENGTH];
	/**
	 * unCosSendBufferLength COS指令发送缓冲长度 
	 */
	unsigned int unCosSendBufferLength;		
	}LotusCardParamStruct;


typedef struct _BssInfoStruct {
    unsigned char arrBssid[8];	//BSSID
    unsigned char arrSsid[32];	//SSID
    unsigned char ucChannel;	//通道
    signed char	scRssi;			//信号强度
    unsigned char ucAuthMode;	//认证模式
}BssInfoStruct;

typedef struct _StaInfoStruct {
    unsigned char arrSsid[16];				//SSID
	unsigned char arrPassword[16];			//Password 密码
	unsigned char arrStaIp[4];				//Sta IP 地址
	//unsigned char arrStaNetMaskIp[4];		//Sta 掩码 地址
	//unsigned char arrStaDnsIp[4];			//Sta DNS 地址

	//unsigned char arrApIp[4];				//Ap IP 地址
	//unsigned char arrApNetMaksIp[4];		//Ap 掩码 地址

	//unsigned char ucStaUseDhcp;			//Sta 使用DHCP获取 1=使用DHCP 0=不使用DHCP
}StaInfoStruct;

//二代证信息结构
typedef struct _TwoIdInfoStruct {
    char arrTwoIdName[30];					//姓名 UNICODE
	char arrTwoIdSex[2];					//性别 UNICODE
	char arrTwoIdNation[4];					//民族 UNICODE
	char arrTwoIdBirthday[16];				//出生日期 UNICODE YYYYMMDD
	char arrTwoIdAddress[70];				//住址 UNICODE
	char arrTwoIdNo[36];					//身份证号码 UNICODE
	char arrTwoIdSignedDepartment[30];		//签发机关 UNICODE
	char arrTwoIdValidityPeriodBegin[16];	//有效期起始日期 UNICODE YYYYMMDD
	char arrTwoIdValidityPeriodEnd[16];		//有效期截止日期 UNICODE YYYYMMDD 有效期为长期时存储“长期”

	char arrTwoIdNewAddress[70];			//最新住址 UNICODE

	unsigned char arrTwoIdPhoto[1024];		//照片信息
	unsigned char arrTwoIdFingerprint[1024];//指纹信息
	unsigned char arrTwoIdPhotoJpeg[4096];	//照片信息 JPEG 格式
	unsigned int  unTwoIdPhotoJpegLength;	//照片信息长度 JPEG格式


}TwoIdInfoStruct;

#pragma pack(push) //保存对齐状态
#pragma pack(1)//设定为1字节对齐
typedef struct _UhfCmdFrameHeadStruct
{
	unsigned char ucFrameBegin;			//数据帧头 == BB
	unsigned char ucFrameType;			//数据帧类型
										//0x00 命令帧: 由上位机发送给 M100/QM100 芯片
										//0x01 响应帧: 由 M100/QM100 芯片发回给上位机
										//0x02 通知帧: 由 M100/QM100 芯片发回给上位机
	unsigned char ucCommand;			//指令
	//unsigned short usParameterLength;	//后续参数长度
	unsigned char ucParameterLengthMSB;	//后续参数长度高字节
	unsigned char ucParameterLengthLSB;	//后续参数长度低字节
	////后续不再定义
	unsigned char ucParameterData;		//参数数据

} UhfCmdFrameHeadStruct;
#pragma pack(pop)//恢复对齐状态
#define EPC_MAX_LENGTH			64		//EPC缓冲长度 一般好像是12字节 搞长点是为了以后有长的
typedef struct _UhfInventoryStruct
{
	unsigned char arrEPCBuffer[EPC_MAX_LENGTH];//EPC缓冲 
	unsigned char ucEPCRealLength;//EPC真实长度
	unsigned char  ucRssi;//型号强度
	unsigned short usPC;//协议控制码 这个信息里面也有EPC长度 考虑方便 和 字节对齐 上面多定义了一个
}UhfInventoryStruct;


#endif

#ifdef __cplusplus
extern "C" {
#endif

	/**
	 * 打开设备
	 * 
	 * @param strDeviceName
	 *            串口设备名称
	 * @param nVID
	 *            USB设备VID
	 * @param nPID
	 *            USB设备PID
	 * @param nUsbDeviceIndex
	 *            USB设备索引
	 * @param unRecvTimeOut
	 *            接收超时
	 * @param pLotusCardExtendReadWriteCallBack 外部读写通道回调函数 只要针对ANDROID 
	 * 			如果没有设备写权限时，可以使用外部USB或串口进行通讯，
	 * 			需要改造callBackProcess中相关代码完成读写工作 目前范例提供USB操作
	 * @return true=成功
	 */
	LotusHandle WINAPI LotusCardOpenDevice(char * pszDeviceName, int nVID, int nPID, int nUsbDeviceIndex, unsigned int unRecvTimeOut, LotusCardExtendReadWriteCallBack  pLotusCardExtendReadWriteCallBack);

	/**
	 * 关闭设备
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 */
	void WINAPI LotusCardCloseDevice(LotusHandle nDeviceHandle);

	/**
	 * 寻卡
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nRequestType
	 *            请求类型
	 * @param tLotusCardParam
	 *            结果值 用里面的卡片类型
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardRequest(LotusHandle nDeviceHandle, int nRequestType,
			LotusCardParamStruct* pLotusCardParam);

	/**
	 * 防冲突
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param tLotusCardParam
	 *            结果值 用里面的卡号
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardAnticoll(LotusHandle nDeviceHandle,
			LotusCardParamStruct* pLotusCardParam);

	/**
	 * 选卡
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param tLotusCardParam
	 *            参数(使用里面的卡号)与结果值(使用里面的卡容量大小)
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSelect(LotusHandle nDeviceHandle,
			LotusCardParamStruct* pLotusCardParam);

	/**
	 * 密钥验证
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAuthMode
	 *            验证模式
	 * @param nSectionIndex
	 *            扇区索引
	 * @param tLotusCardParam
	 *            参数(使用里面的卡号)
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardAuthentication(LotusHandle nDeviceHandle, int nAuthMode,
			int nSectionIndex, LotusCardParamStruct* pLotusCardParam);

	/**
	 * 卡片中止响应
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardHalt(LotusHandle nDeviceHandle);

	/**
	 * 读指定地址数据
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAddress 块地址
	 * @param tLotusCardParam 结果值（读写缓冲）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardRead(LotusHandle nDeviceHandle, int nAddress, LotusCardParamStruct* pLotusCardParam);
	
	/**
	 * 写指定地址数据
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAddress 块地址
	 * @param tLotusCardParam 参数（读写缓冲）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardWrite(LotusHandle nDeviceHandle, int nAddress, LotusCardParamStruct* pLotusCardParam);
	
	/**
	 * 加值
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAddress 块地址
	 * @param nValue 值
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardIncrement(LotusHandle nDeviceHandle, int nAddress, int nValue);
	
	/**
	 * 减值
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAddress 块地址
	 * @param nValue 值
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardDecrement(LotusHandle nDeviceHandle, int nAddress,int nValue);
	
	/**
	 * 卡数据块传入卡的内部寄存器
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAddress 块地址
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardRestore(LotusHandle nDeviceHandle, int nAddress);
	/**
	 * 内部寄存器传入卡的卡数据块
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAddress 块地址
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardTransfer(LotusHandle nDeviceHandle, int nAddress);

	/**
	 * 装载密钥
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAuthMode 验证模式
	 * @param nSectionIndex 扇区索引
	 * @param tLotusCardParam 参数（密钥）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardLoadKey(LotusHandle nDeviceHandle,int nAuthMode, int nSectionIndex, LotusCardParamStruct* pLotusCardParam);
	
	/**
	 * 蜂鸣
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nDeviceHandle 设备句柄
	 * @param nBeepLen 蜂鸣长度 毫秒为单位
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardBeep(LotusHandle nDeviceHandle, int nBeepLen);

	/**
	 * 清空缓冲
	 * @param nDeviceHandle 设备句柄
	 * @param tLotusCardParam 结果值（读写缓冲）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardEmptyBuffer(long nDeviceHandle, LotusCardParamStruct* pLotusCardParam);

	/**
	 * 发送指令 用于CPU卡
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nTimeOut 超时参数
	 * @param tLotusCardParam 参数（指令缓冲,返回结果）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSendCpuCommand(LotusHandle nDeviceHandle, int nTimeOut, LotusCardParamStruct* pLotusCardParam);

	/********************************以下函数调用上述函数，为了简化第三方调用操作***************************/
	/**
	* 读指定地址文本
	* @param nSectionIndex 扇区索引
	* @param pTextInfo 结果值（读写缓冲）
	* @param unTextInfoLength 文本缓冲长度
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardReadText(LotusHandle nDeviceHandle, int nSectionIndex, char * pTextInfo, unsigned int unTextInfoLength);
	/**
	* 写指定地址文本
	* @param nSectionIndex 扇区索引
	* @param pTextInfo 结果值（读写缓冲）
	* @param unTextInfoLength 文本缓冲长度
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardWriteText(LotusHandle nDeviceHandle, int nSectionIndex, char * pTextInfo, unsigned int unTextInfoLength);

	/**
	 * 获取卡号 上位机简化
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nRequestType
	 *            请求类型
	 * @param tLotusCardParam
	 *            结果值 
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardGetCardNo(LotusHandle nDeviceHandle, int nRequestType,
			LotusCardParamStruct* pLotusCardParam);
	/**
	 * 获取卡号 MCU简化
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nRequestType
	 *            请求类型
	* @param ucBeepLen 蜂鸣长度 最长255毫秒
	* @param ucUseHalt 使用中止 1=调用中止操作 0=不动作
	* @param ucUseLoop 使用循环 
	*        1=读卡器内部循环获取卡号 获取到数据再返回 上位机接收超时后 应立即再次读取
	*        0=读卡器内部只动作一次
	 * @param tLotusCardParam
	 *            结果值 
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardGetCardNoEx(LotusHandle nDeviceHandle, int nRequestType, unsigned char ucBeepLen, unsigned char ucUseHalt, 
		unsigned char ucUseLoop, LotusCardParamStruct* pLotusCardParam);
	/**
	 * 初始值
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAddress 块地址
	 * @param nValue 值
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardInitValue(LotusHandle nDeviceHandle,  int nAddress, int nValue);

	/**
	 * 修改密码AB
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pPasswordA 密码A
	 * @param pPasswordB 密码B
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardChangePassword(LotusHandle nDeviceHandle, int nSectionIndex, const char * pPasswordA, const  char * pPasswordB);

	/**
	 * 设置外部读写函数
	* @param nDeviceHandle
	*            设备句柄
	 * @param pLotusCardExtendReadWriteCallBack 外部读写操作函数
	 * @return 
	 */
	void WINAPI LotusCardSetExtendReadWrite(LotusHandle nDeviceHandle, LotusCardExtendReadWriteCallBack  pLotusCardExtendReadWriteCallBack);

	/**
	 * 复位CPU卡
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param tLotusCardParam
	 *            结果值 
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardResetCpuCard(LotusHandle nDeviceHandle, LotusCardParamStruct* pLotusCardParam);

	/**
	 * 发送指令 用于CPU卡 封装LotusCardSendCpuCommand
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param tLotusCardParam 参数（指令缓冲,返回结果）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSendCOSCommand(LotusHandle nDeviceHandle, LotusCardParamStruct* pLotusCardParam);
	/**
	* 获取银行卡卡号
	* @param nDeviceHandle
	* @param pBankCardNo 银行卡号 同印刷号码
	* @param unBankCardNoLength 银行卡号长度
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardGetBankCardNo(LotusHandle nDeviceHandle, char * pBankCardNo, unsigned int unBankCardNoLength);
	/**
	 * 进入Esp isp模式
	 * @param nDeviceHandle
	 *            设备句柄
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSendEspEnterIspCommand(LotusHandle nDeviceHandle);
	/**
	 * 发送Esp isp开始动作
	 * @param nDeviceHandle
	 *            设备句柄
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSendEspIspBeginCommand(LotusHandle nDeviceHandle);

	/**
	 * 写文件到ESP FLASH
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pszFilePath
	 *            文件路径
	 * @param unOffset
	 *            FLASH 偏移量
	 * @param pOnLotusCardWrite2FlashCallBack
	 *            回调函数 用于处理进度显示
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardWriteEspFile2Flash(LotusHandle nDeviceHandle, char * pszFilePath, unsigned int unOffset, LotusCardWrite2FlashCallBack  pOnLotusCardWrite2FlashCallBack);
	/**
	 * 发送Esp isp结束动作
	 * @param nDeviceHandle
	 *            设备句柄
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSendEspIspEndCommand(LotusHandle nDeviceHandle);

	/**
	* 读指定地址数据 一个指令就完成所有动作
	* @param nDeviceHandle
	*            设备句柄
	* @param nRequestType
	*            请求类型
	* @param nAddress 块地址
	* @param ucUsePassWord 使用密码 1=使用参数密码 0 =使用设备内部密码
	* @param ucBeepLen 蜂鸣长度 最长255毫秒
	* @param ucUseHalt 使用中止
	* @param tLotusCardParam 结果值（读写缓冲）
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardReadData(LotusHandle nDeviceHandle, int nRequestType, int nAddress, unsigned char ucUseParameterPassWord, 
		unsigned char ucBeepLen, unsigned char ucUseHalt, LotusCardParamStruct* pLotusCardParam);

	/**
	 * 写指定地址数据
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nAddress 块地址
	 * @param ucBeepLen 蜂鸣长度 最长255毫秒
	 * @param ucUseHalt 使用中止
	 * @param tLotusCardParam 参数（读写缓冲）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardWriteData(LotusHandle nDeviceHandle,  int nAddress, unsigned char ucBeepLen, unsigned char ucUseHalt, LotusCardParamStruct* pLotusCardParam);
	/******************************** 以下函数为WIFI操作函数 ***************************/
	/**
	 * 扫描AP
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pBssInfoArray 装载返回AP信息数组
	 * @param unBssInfoArraySize 装载返回AP数组大小
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardScanAp(LotusHandle nDeviceHandle, BssInfoStruct * pBssInfoArray, unsigned int unBssInfoArraySize);

	/**
	* 获取WIFI 工作模式
	 * @param nDeviceHandle
	 *            设备句柄
	* @param pucWifiMode
	*            模式返回值
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardGetWifiMode(LotusHandle nDeviceHandle, unsigned char * pucWifiMode);

	/**
	* 设置WIFI 工作模式
	 * @param nDeviceHandle
	 *            设备句柄
	* @param ucWifiMode
	*            模式值
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardSetWifiMode(LotusHandle nDeviceHandle, unsigned char ucWifiMode);

	/**
	* 获取TA信息
	 * @param nDeviceHandle
	 *            设备句柄
	* @param pStaInfoStruct
	*            STA相关参数
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardGetStaInfo(LotusHandle nDeviceHandle,StaInfoStruct * pStaInfoStruct);
	/**
	* 设置STA信息
	 * @param nDeviceHandle
	 *            设备句柄
	* @param pStaInfoStruct
	*            STA相关参数
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardSetStaInfo(LotusHandle nDeviceHandle, StaInfoStruct * pStaInfoStruct);


	/**
	* 连接测试
	 * @param pServerIp
	 *            服务器IP地址
	* @param nConnectTimeOut
	*            超时us为单位
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardConnectTest(char * pServerIp, int nConnectTimeOut);

	/**
	* 获取错误编码 
	 * @param nDeviceHandle
	 *            设备句柄
	* @return 错误编码 详见枚举值定义
	*/
	unsigned int WINAPI LotusCardGetErrorCode(LotusHandle nDeviceHandle);

	/**
	* 获取二代证操作错误编码 
	 * @param nDeviceHandle
	 *            设备句柄
	* @return 错误编码 详见枚举值定义
	*/
	unsigned int WINAPI LotusCardGetTwoIdErrorCode(long nDeviceHandle);

	/**
	 * 设置卡片类型
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param cCardType 卡片类型 A='A'/'a' B='B'/'b' F='F'/'f' C='C'/'c'
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSetCardType( LotusHandle nDeviceHandle, char cCardType);

	/**
	 * Felica寻卡 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param unTimerSlot timer slot
	 * @param tLotusCardParam 参数（读写缓冲）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardFelicaPolling(LotusHandle nDeviceHandle, unsigned char unTimerSlot, LotusCardParamStruct* pLotusCardParam);

	/**
	 * 发送SAMV命令
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param tLotusCardParam 参数（读写缓冲）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSendSamvCommand(LotusHandle nDeviceHandle, LotusCardParamStruct* pLotusCardParam);

	/**
	 * 发送COS指令结果给SAMV
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param tLotusCardParam 参数（读写缓冲）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSendCosResult2Samv(long nDeviceHandle, LotusCardParamStruct* pLotusCardParam);
	
	/**
	 * 获取安全模块串口数据
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param tLotusCardParam 参数（读写缓冲）
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardGetSamvUartData(long nDeviceHandle, LotusCardParamStruct* pLotusCardParam);

	/**
	 * 获取二代证信息
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pTwoIdInfo 参数 二代证信息结构体地址
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardGetTwoIdInfo(LotusHandle nDeviceHandle, TwoIdInfoStruct * pTwoIdInfo);

	/**
	* 读取NFC缓冲
	 * @param nDeviceHandle
	 *            设备句柄
	* @param pszNfcBuffer
	*            缓冲地址
	* @param unNfcBufferLength
	*            缓冲长度
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardReadNfcBuffer(LotusHandle nDeviceHandle, char * pszNfcBuffer, unsigned int unNfcBufferLength);

	/**
	* 写入NFC缓冲
	 * @param nDeviceHandle
	 *            设备句柄
	* @param pszNfcBuffer
	*            缓冲地址
	* @param unNfcBufferLength
	*            缓冲长度
	* @return true = 成功
	*/
	BOOL WINAPI LotusCardWriteNfcBuffer(LotusHandle nDeviceHandle, char * pszNfcBuffer, unsigned int unNfcBufferLength);

	/******************************** 以下函数为type b操作函数 ***************************/
	/**
	 * 寻卡
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param nRequestType
	 *            请求类型
	 * @param tLotusCardParam
	 *            结果值 用里面的卡片类型
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardRequestB(LotusHandle nDeviceHandle, int nRequestType,
			LotusCardParamStruct* pLotusCardParam);



	/**
	 * 选卡
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param tLotusCardParam
	 *            参数(使用里面的卡号)与结果值(使用里面的卡容量大小)
	 * @return true = 成功
	 */
	BOOL WINAPI LotusCardSelectB(LotusHandle nDeviceHandle,
			LotusCardParamStruct* pLotusCardParam);


	/**
	 * 卡片中止响应
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardHaltB(LotusHandle nDeviceHandle);

	/**
	 * 获取超高频固件信息
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucVersionType 
	 *			  参数 版本类型 硬件版本  0x00 软件版本 0x01  制造商信息  0x02
	 * @param pUhfFwVersionInfo 
	 *			  参数 超高频固件版本信息字串地址
	 * @param unVersionInfoLength 
	 *			  参数 字串分配内存长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardGetUhfFwVersion(LotusHandle nDeviceHandle, unsigned char ucVersionType, char * pUhfFwVersionInfo,  unsigned int unVersionInfoLength);


	/**
	* 发送M100系列UHF 单次轮询指令
	* 
	* @param nDeviceHandle
	*            设备句柄
	* @param unInventoryCount 
	*			  参数 盘存返回的标签总数
	* @return true = 成功
	*/
	BOOL  WINAPI LotusCardM100UhfInventory(LotusHandle nDeviceHandle, unsigned int & unInventoryCount);

	/**
	 * 发送M100系列UHF 获取盘存返回信息 在单次轮询/多次轮询后调用 以后如果需要也可以搞成回调的方式 搞个线程处理 不过有点麻烦 暂时就这样 wdy 2015-05-04
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucInventoryIndex 
	 *			  参数 盘存返回信息的索引
	 * @param pUhfInventory 
	 *			  参数 盘存返回信息结构体指针
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfGetInventoryStruct(LotusHandle nDeviceHandle, unsigned char ucInventoryIndex, UhfInventoryStruct * pUhfInventory);

	/**
	 * 发送M100系列UHF 多次轮询指令
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucRssi 
	 *			  参数 获取RSSI
	 * @param ucPC 
	 *			  参数 获取PC
	 * @param pEPCBuffer 
	 *			  参数 获取EPC 存放地址
	 * @param unEPCBufferLength 
	 *			  参数 EPC存放缓冲长度
	 * @param unEPCLength 
	 *			  参数 获取EPC实际长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfReadMulti(LotusHandle nDeviceHandle,unsigned char & ucRssi, unsigned short & usPC, unsigned char * pEPCBuffer, 
		unsigned int unEPCBufferLength, unsigned int & unEPCLength);

	/**
	 * 发送M100系列UHF 停止多次轮询指令
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfStopMulti(LotusHandle nDeviceHandle);

	/**
	 * 发送M100系列UHF 获取发射功率
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param usPower 
	 *			  参数 0x07D0(当前功率为十进制2000，即20dBm)
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfGetPower(LotusHandle nDeviceHandle, unsigned short & usPower);


	/**
	 * 发送M100系列UHF 设置发射功率
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param usPower 
	 *			  参数 0x07D0(当前功率为十进制2000，即20dBm)
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetPower(LotusHandle nDeviceHandle, unsigned short usPower);

	/**
	 * 发送M100系列UHF 设置工作地区
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucRegion 
	 *			  参数 中国900MHz 01 中国800MHz 04 美国02 欧洲03 韩国06 
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetRegion(LotusHandle nDeviceHandle, unsigned char ucRegion);

	/**
	 * 发送M100系列UHF 获取工作信道
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucRfChannel 
	 *			  参数 0x00(Channel_Index 为0x00)
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfGetRfChannel(LotusHandle nDeviceHandle, unsigned char & ucRfChannel);

	/**
	 * 发送M100系列UHF 设置工作信道
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucRfChannel 
	 *			  参数 0x00(Channel_Index 为0x00)
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetRfChannel(LotusHandle nDeviceHandle, unsigned char ucRfChannel);

	/**
	 * 发送M100系列UHF 设置自动跳频
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucFHSS 
	 *			  参数 0xFF(0xFF 为设置自动跳频，0x00 为取消自动跳频)
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetFHSS(LotusHandle nDeviceHandle, unsigned char ucFHSS);

	/**
	 * 发送M100系列UHF 获取Query 参数
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param usQueryParameter 
	 *			  参数 设置Query 命令中的相关参数。参数为2 字节，有下面的具体参数按位拼接而成：
	 *DR(1 bit): DR=8(1’b0), DR=64/3(1’b1). 只支持DR=8 的模式
	 *M(2 bit): M=1(2’b00), M=2(2’b01), M=4(2’b10), M=8(2’b11). 只支持M=1 的模式
	 *TRext(1 bit): No pilot tone(1’b0), Use pilot tone(1’b1). 只支持Use pilot tone(1’b1)模式
	 *Sel(2 bit): ALL(2’b00/2’b01), ~SL(2’b10), SL(2’b11)
	 *Session(2 bit): S0(2’b00), S1(2’b01), S2(2’b10), S3(2’b11)
	 *Target(1 bit): A(1’b0), B(1’b1)
	 *Q(4 bit): 4’b0000-4’b1111
	 *如果DR=8, M=1, TRext=Use pilot tone, Sel=00, Session=00, Target=A, Q=4，则指令如下：
	 *BB 00 0E 00 02 10 20 40 7E
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfGetQueryParamter(LotusHandle nDeviceHandle, unsigned short &  usQueryParameter);

	/**
	 * 发送M100系列UHF 设置Query 参数
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param usQueryParameter 
	 *			  参数 设置Query 命令中的相关参数。参数为2 字节，有下面的具体参数按位拼接而成：
	 *DR(1 bit): DR=8(1’b0), DR=64/3(1’b1). 只支持DR=8 的模式
	 *M(2 bit): M=1(2’b00), M=2(2’b01), M=4(2’b10), M=8(2’b11). 只支持M=1 的模式
	 *TRext(1 bit): No pilot tone(1’b0), Use pilot tone(1’b1). 只支持Use pilot tone(1’b1)模式
	 *Sel(2 bit): ALL(2’b00/2’b01), ~SL(2’b10), SL(2’b11)
	 *Session(2 bit): S0(2’b00), S1(2’b01), S2(2’b10), S3(2’b11)
	 *Target(1 bit): A(1’b0), B(1’b1)
	 *Q(4 bit): 4’b0000-4’b1111
	 *如果DR=8, M=1, TRext=Use pilot tone, Sel=00, Session=00, Target=A, Q=4，则指令如下：
	 *BB 00 0E 00 02 10 20 40 7E
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetQueryParamter(LotusHandle nDeviceHandle,  unsigned short usQueryParameter);

	/**
	 * 发送M100系列UHF 设置发射连续载波
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucCW 
	 *			  参数 0xFF 为打开连续波，0x00 为关闭连续波
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetCW(LotusHandle nDeviceHandle, unsigned char ucCW);

	/**
	 * 发送M100系列UHF 测试射频输入端阻塞信号
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucChannelLow 
	 *			  参数 信道最低数值
	 * @param ucChannelHigh 
	 *			  参数 信道最高数值
	 * @param parrJammerBuffer 
	 *			  参数 Jammer数组缓冲地址
	 * @param unJammerBufferLength 
	 *			  参数 Jammer数组缓冲长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfScanJammer(LotusHandle nDeviceHandle, unsigned char & ucChannelLow,  unsigned char & ucChannelHigh, unsigned char * parrJammerBuffer, unsigned int & unJammerBufferLength );

	/**
	 * 发送M100系列UHF 测试信道RSSI
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucChannelLow 
	 *			  参数 信道最低数值
	 * @param ucChannelHigh 
	 *			  参数 信道最高数值
	 * @param parrRssiBuffer 
	 *			  参数 RSSI数组缓冲地址
	 * @param unRssiBufferLength 
	 *			  参数 RSSI数组缓冲长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfScanRssi(LotusHandle nDeviceHandle, unsigned char & ucChannelLow,  unsigned char & ucChannelHigh, unsigned char * parrRssiBuffer, unsigned int & unRssiBufferLength );

	/**
	 * 发送M100系列UHF 获取接收解调器参数
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucMixerGain 
	 *			  参数 混频器增益
	 * @param ucIFGain 
	 *			  参数 中频放大器增益
	 * @param usThrd 
	 *			  参数 信号解调阈值
	 * @param unJammerBufferLength 
	 *			  参数 Jammer数组缓冲长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfReadModemParameter(LotusHandle nDeviceHandle, unsigned char & ucMixerGain,  unsigned char & ucIFGain, unsigned short & usThrd);

	/**
	 * 发送M100系列UHF 设置接收解调器参数
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucMixerGain 
	 *			  参数 混频器增益
	 * @param ucIFGain 
	 *			  参数 中频放大器增益
	 * @param usThrd 
	 *			  参数 信号解调阈值
	 * @param unJammerBufferLength 
	 *			  参数 Jammer数组缓冲长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetModemParameter(LotusHandle nDeviceHandle, unsigned char ucMixerGain,  unsigned char ucIFGain, unsigned short usThrd);

	/**
	 * 发送M100系列UHF 设置Inventory模式
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucInventoryMode 
	 *			  参数 Inventory模式
	 *			  Select 模式Mode 含义：
	 *			  0x00: 在对标签的所有操作之前都预先发送Select 指令选取特定的标签。
	 *			  0x01: 在对标签操作之前不发送Select 指令。
	 *			  0x02: 仅对除轮询Inventory 之外的标签操作之前发送Select 指令，如在
	 *			  Read，Write，Lock，Kill 之前先通过Select 选取特定的标签。
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetInventoryMode(LotusHandle nDeviceHandle, unsigned char ucInventoryMode);

	/**
	 * 发送M100系列UHF 设置选择参数
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param ucSelParam 
	 *			  参数 0x01 (Target: 3’b000, Action: 3’b000, MemBank: 2’b01)
	 * @param unPtr 
	 *			  参数 0x00000020(以bit 为单位，非word) 从EPC 存储位开始
	 * @param ucMaskLen 
	 *			  参数 0x60(6 个word，96bits)
	 * @param ucTruncate 
	 *			  参数 0x00(0x00 是Disable truncation，0x80 是Enable truncation)
	 * @param parrMask 
	 *			  参数 Mask缓冲地址
	 * @param unMaskLength 
	 *			  参数 Mask缓冲长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfSetSelectParameter(LotusHandle nDeviceHandle, unsigned char ucSelParam, unsigned int unPtr, unsigned char ucMaskLen, unsigned char ucTruncate,
		unsigned char * parrMask, unsigned int unMaskLength);


	/**
	 * 发送M100系列UHF 读取数据
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param unAccessPassword 
	 *			  参数 访问密码
	 * @param ucMemBank 
	 *			  参数 标签数据存储区
	 * @param usSAdreess 
	 *			  参数 读标签数据区地址偏移
	 * @param usDataLength 
	 *			  参数 读标签数据区地址长度 WORD为单位
	 * @param parrDataBuffer 
	 *			  参数 数据缓冲地址
	 * @param unDataBufferLength 
	 *			  参数 数据缓冲长度 送入buffer长度 返回实际长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfReadData(LotusHandle nDeviceHandle, unsigned int unAccessPassword, unsigned char ucMemBank, unsigned short usSAdreess,  unsigned short usDataLength,
		unsigned char * parrDataBuffer, unsigned int & unDataBufferLength);

	/**
	 * 发送M100系列UHF 写标签数据存储区
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param unAccessPassword 
	 *			  参数 访问密码
	 * @param ucMemBank 
	 *			  参数 标签数据存储区
	 * @param usSAdreess 
	 *			  参数 读标签数据区地址偏移
	 * @param usDataLength 
	 *			  参数 读标签数据区地址长度 WORD为单位
	 * @param parrDataBuffer 
	 *			  参数 数据缓冲地址
	 * @param unDataBufferLength 
	 *			  参数 数据缓冲长度 送入buffer长度 返回实际长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfWriteData(LotusHandle nDeviceHandle, unsigned int unAccessPassword, unsigned char ucMemBank, unsigned short usSAdreess,  unsigned short usDataLength,
		unsigned char * parrDataBuffer, unsigned int & unDataBufferLength);

	/**
	 * 发送M100系列UHF 锁定Lock 标签数据存储区
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param unAccessPassword 
	 *			  参数 访问密码
	 * @param parrLockLd 
	 *			  参数 LockLd数组缓冲地址
	 * @param unLockLdLength 
	 *			  参数 LockLd数组缓冲长度
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfLockUnLock(LotusHandle nDeviceHandle, unsigned int unAccessPassword, unsigned char * parrLockLd, unsigned int unLockLdLength);

	/**
	 * 发送M100系列UHF 灭活Kill 标签
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param unKillPassword 
	 *			  参数 KILL密码
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardM100UhfKill(LotusHandle nDeviceHandle, unsigned int unKillPassword);
	/**
	 * 获取设备号
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param parrDeviceNo 
	 *			  参数 设备号缓冲地址
	 * @param unDeviceNoLength 
	 *			  参数 设备号缓冲长度 目前不小于8字节 以后可能有调整
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardGetDeviceNo(LotusHandle nDeviceHandle, char * pstrDeviceNo,  unsigned int unDeviceNoLength);

	/**
	 * 获取二代身份证卡片ID
	 * 
 	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pstrTwoGenerationID 
	 *			  参数 二代身份证ID缓冲地址
	 * @param unTwoGenerationIDLength 
	 *			  参数 二代身份证ID缓冲长度 
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardGetTwoGenerationIDCardNo(LotusHandle nDeviceHandle, char * pstrTwoGenerationID,  unsigned int unTwoGenerationIDLength);


	/**
	 * 获取服务器IP PORT
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param punIpAddress 
	 *			  参数 IP地址
	 * @param pusPort 
	 *			  参数 端口
	 * @return true = 成功
	 */
	BOOL  WINAPI LotusCardGetServerIpPort(long nDeviceHandle, unsigned int * punIpAddress, unsigned short * pusPort);

	/**
	 * 根据编码获取性别字符串
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pszSexCode 
	 *			  参数 性别编码 0 未知 2 女 1 男 9 未说明
	 * @param pszSexBuffer 
	 *			  结果 存放返回字符串
	 * @param nSexBufferLength 
	 *			  参数 buffer长度
	 * @return true = 成功
	 */
	void  WINAPI LotusCardGetTwoIdSexByCode(long nDeviceHandle, char * pszSexCode, char * pszSexBuffer, int nSexBufferLength);
	/**
	 * 根据编码获取民族字符串
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pszNationCode 
	 *			  参数 民族编码
	 * @param pszNationBuffer 
	 *			  结果 存放返回字符串
	 * @param nNationBufferLength 
	 *			  参数 buffer长度
	 * @return true = 成功
	 */
	void  WINAPI LotusCardGetTwoIdNationByCode(long nDeviceHandle, char * pszNationCode, char * pszNationBuffer, int nNationBufferLength);

	/**
	 * b64编码
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pSrcDataBuffer 
	 *			  参数 源数据缓冲
	 * @param nSrcDataLen 
	 *			  参数 源数据缓冲长度
	 * @param pDestDataBuffer 
	 *			  参数 目标Buffer
	 * @param nDestDataLen 
	 *			  参数 目标Buffer长度
	 * @return true = 成功
	 */
	void  WINAPI LotusCardBase64Encode(long nDeviceHandle, unsigned char* pSrcDataBuffer, int nSrcDataLen, unsigned char* pDestDataBuffer, int nDestDataLen);

	/**
	 * 获取b64编码后长度
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pSrcDataBuffer 
	 *			  参数 源数据缓冲
	 * @param nSrcDataLen 
	 *			  参数 源数据缓冲长度
	 */
	int WINAPI LotusCardGetEncodeNewLen(long nDeviceHandle, const char * pSrcDataBuffer, int nSrcDataLen);

	/**
	 * b64解码
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pSrcDataBuffer 
	 *			  参数 源数据缓冲
	 * @param nSrcDataLen 
	 *			  参数 源数据缓冲长度
	 * @param pDestDataBuffer 
	 *			  参数 目标Buffer
	 * @param nDestDataLen 
	 *			  参数 目标Buffer长度
	 * @return true = 成功
	 */
	void  WINAPI LotusCardBase64Decode(long nDeviceHandle, unsigned char* pSrcDataBuffer, int nSrcDataLen, unsigned char* pDestDataBuffer, int nDestDataLen);

	/**
	 * 获取b64解码后长度
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pSrcDataBuffer 
	 *			  参数 源数据缓冲
	 * @param nSrcDataLen 
	 *			  参数 源数据缓冲长度
	 */
	int WINAPI LotusCardGetDecodeNewLen(long nDeviceHandle, const char* pSrcDataBuffer, int nSrcDataLen);

	/**
	 * 获取二代证用随机数
	 * 
	 * @param nDeviceHandle
	 *            设备句柄
	 * @param pszRandom 
	 *			  参数 随机数缓冲
	 * @param unRandomLength 
	 *			  参数 随机数缓冲长度
	 */
	void WINAPI LotusCardGetIdRandom(long nDeviceHandle, unsigned char * pszRandom, unsigned int unRandomLength);


#ifdef __cplusplus
}
#endif

#endif//__LOTUS_CARD_DRIVER_H__
